﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Dapfor.Net.Data;

namespace DapForDynamicComputationColumn
{
    public partial class Form1 : Form
    {
        ThreadSafeBindingList<MyData> _Bind = new ThreadSafeBindingList<MyData>();
        Random _r = new Random();
        System.Timers.Timer _timer = new System.Timers.Timer(1000);
        public Form1()
        {
            InitializeComponent();
            this.grid1.DataSource = _Bind;
            GenerateData();
            _timer.Elapsed += new System.Timers.ElapsedEventHandler(_timer_Elapsed);
        }

        void _timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            _Bind[_r.Next(0, _Bind.Count)].Price = _r.Next(100, 500);
            _Bind[_r.Next(0, _Bind.Count)].Qty = _r.Next(100, 500);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        void GenerateData()
        {
            
            for (int i = 0; i < 10; i++)
            {
                MyData _objData = new MyData();
                _objData.Name = ((char)_r.Next(97, 120)).ToString();
                _objData.Price = _r.Next(i, 500);
                _objData.Qty  = _r.Next(i, 500);
                _Bind.Add(_objData);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            _timer.Enabled = !_timer.Enabled;
        }
    }

    class MyData : INotifyPropertyChanged
    {
        string  _Name;
        int     _Qty;
        int     _Price;

        [Field("Price")]
        public int Price
        {
            get { return _Price; }
            set { _Price = value; Notify("Price"); }
        }

        [Field("Qty")]
        public int Qty
        {
            get { return _Qty; }
            set { _Qty = value; Notify("Qty"); }
        }

        [Field("Name")]
        public string Name
        {
            get { return _Name; }
            set { _Name = value; Notify("Name"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        void Notify(string Name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(Name));
        }
    }
}
